3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # for git on windows so stdin will not be misdetected as attached to a
22 # if --tee was passed, write the output not only to the terminal, but
23 # additionally to the file test-results/$BASENAME.out, too.
24 case "$GIT_TEST_TEE_STARTED, $* " in
26 # do not redirect again
28 *' --tee '*|
*' --va'*)
30 BASE
=test-results
/$
(basename "$0" .sh
)
31 (GIT_TEST_TEE_STARTED
=done ${SHELL-sh} "$0" "$@" 2>&1;
32 echo $?
> $BASE.
exit) |
tee $BASE.out
33 test "$(cat $BASE.exit)" = 0
38 # Keep the original TERM for say_color
41 # For repeatability, reset the environment to known value.
47 export LANG LC_ALL PAGER TERM TZ
53 my $ok = join("|", qw(
62 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
63 print join("\n", @vars);
65 GIT_AUTHOR_EMAIL
=author@example.com
66 GIT_AUTHOR_NAME
='A U Thor'
67 GIT_COMMITTER_EMAIL
=committer@example.com
68 GIT_COMMITTER_NAME
='C O Mitter'
70 export GIT_MERGE_VERBOSITY
71 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
72 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
75 # Protect ourselves from common misconfiguration to export
76 # CDPATH into the environment
81 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
83 echo "* warning: Some tests will not work if GIT_TRACE" \
84 "is set as to trace on STDERR ! *"
85 echo "* warning: Please set GIT_TRACE to something" \
86 "other than 1, 2 or true ! *"
92 # A regexp to match 5 and 40 hexdigits
93 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
94 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
97 _z40
=0000000000000000000000000000000000000000
99 # Each test should start with something like this, after copyright notices:
101 # test_description='Description of this test...
102 # This test checks if command xyzzy does the right thing...
105 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
106 TERM
=$ORIGINAL_TERM &&
109 tput bold
>/dev
/null
2>&1 &&
110 tput setaf
1 >/dev
/null
2>&1 &&
111 tput sgr0
>/dev
/null
2>&1
115 while test "$#" -ne 0
118 -d|
--d|
--de|
--deb|
--debu|
--debug)
120 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
121 immediate
=t
; shift ;;
122 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
123 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
124 -h|
--h|
--he|
--hel|
--help)
126 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
128 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
129 # Ignore --quiet under a TAP::Harness. Saying how many tests
130 # passed without the ok/not ok details is always an error.
131 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
133 with_dashes
=t
; shift ;;
136 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
137 valgrind
=t
; verbose
=t
; shift ;;
139 shift ;; # was handled already
141 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
144 echo "error: unknown test option '$1'" >&2; exit 1 ;;
148 if test -n "$color"; then
154 error
) tput bold
; tput setaf
1;; # bold red
155 skip
) tput bold
; tput setaf
2;; # bold green
156 pass
) tput setaf
2;; # green
157 info
) tput setaf
3;; # brown
158 *) test -n "$quiet" && return;;
168 test -z "$1" && test -n "$quiet" && return
175 say_color error
"error: $*"
184 test "${test_description}" != "" ||
185 error
"Test script did not set test_description."
187 if test "$help" = "t"
189 echo "$test_description"
194 if test "$verbose" = "t"
198 exec 4>/dev
/null
3>/dev
/null
207 test_external_has_tap
=0
211 if test -n "$GIT_EXIT_OK"
215 echo >&5 "FATAL: Unexpected exit with code $code"
223 # The semantics of the editor variables are that of invoking
224 # sh -c "$EDITOR \"$@\"" files ...
226 # If our trash directory contains shell metacharacters, they will be
227 # interpreted if we just set $EDITOR directly, so do a little dance with
228 # environment variables to work around this.
230 # In particular, quoting isn't enough, as the path may contain the same quote
235 EDITOR
='"$FAKE_EDITOR"'
239 test_decode_color
() {
242 if (n == 0) return "RESET";
243 if (n == 1) return "BOLD";
244 if (n == 30) return "BLACK";
245 if (n == 31) return "RED";
246 if (n == 32) return "GREEN";
247 if (n == 33) return "YELLOW";
248 if (n == 34) return "BLUE";
249 if (n == 35) return "MAGENTA";
250 if (n == 36) return "CYAN";
251 if (n == 37) return "WHITE";
252 if (n == 40) return "BLACK";
253 if (n == 41) return "BRED";
254 if (n == 42) return "BGREEN";
255 if (n == 43) return "BYELLOW";
256 if (n == 44) return "BBLUE";
257 if (n == 45) return "BMAGENTA";
258 if (n == 46) return "BCYAN";
259 if (n == 47) return "BWHITE";
262 while (match($0, /\033\[[0-9;]*m/) != 0) {
263 printf "%s<", substr($0, 1, RSTART-1);
264 codes = substr($0, RSTART+2, RLENGTH-3);
265 if (length(codes) == 0)
268 n = split(codes, ary, ";");
270 for (i = 1; i <= n; i++) {
271 printf "%s%s", sep, name(ary[i]);
276 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
300 sed -e 's/$/Q/' |
tr Q
'\015'
304 tr '\015' Q |
sed -e 's/Q$//'
307 # In some bourne shell implementations, the "unset" builtin returns
308 # nonzero status when a variable to be unset was not set in the first
311 # Use sane_unset when that should not be considered an error.
319 if test -z "${test_tick+set}"
323 test_tick
=$
(($test_tick + 60))
325 GIT_COMMITTER_DATE
="$test_tick -0700"
326 GIT_AUTHOR_DATE
="$test_tick -0700"
327 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
330 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
332 # This will commit a file with the given contents and the given commit
333 # message. It will also add a tag with <message> as name.
335 # Both <file> and <contents> default to <message>.
339 echo "${3-$1}" > "$file" &&
342 git commit
-m "$1" &&
346 # Call test_merge with the arguments "<message> <commit>", where <commit>
347 # can be a tag pointing to the commit-to-merge.
351 git merge
-m "$1" "$2" &&
355 # This function helps systems where core.filemode=false is set.
356 # Use it instead of plain 'chmod +x' to set or unset the executable bit
357 # of a file in the working directory and add it to the index.
361 git update-index
--add "--chmod=$@"
364 # Use test_set_prereq to tell that a particular prerequisite is available.
365 # The prerequisite can later be checked for in two ways:
367 # - Explicitly using test_have_prereq.
369 # - Implicitly by specifying the prerequisite tag in the calls to
370 # test_expect_{success,failure,code}.
372 # The single parameter is the prerequisite tag (a simple word, in all
373 # capital letters by convention).
376 satisfied
="$satisfied$1 "
380 test_have_prereq
() {
381 # prerequisites can be concatenated with ','
393 total_prereq
=$
(($total_prereq + 1))
396 ok_prereq
=$
(($ok_prereq + 1))
399 # Keep a list of missing prerequisites
400 if test -z "$missing_prereq"
402 missing_prereq
=$prerequisite
404 missing_prereq
="$prerequisite,$missing_prereq"
409 test $total_prereq = $ok_prereq
412 test_declared_prereq
() {
413 case ",$test_prereq," in
421 # You are not expected to call test_ok_ and test_failure_ directly, use
422 # the text_expect_* functions instead.
425 test_success
=$
(($test_success + 1))
426 say_color
"" "ok $test_count - $@"
430 test_failure
=$
(($test_failure + 1))
431 say_color error
"not ok - $test_count $1"
433 echo "$@" |
sed -e 's/^/# /'
434 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
437 test_known_broken_ok_
() {
438 test_fixed
=$
(($test_fixed+1))
439 say_color
"" "ok $test_count - $@ # TODO known breakage"
442 test_known_broken_failure_
() {
443 test_broken
=$
(($test_broken+1))
444 say_color skip
"not ok $test_count - $@ # TODO known breakage"
448 test "$debug" = "" ||
eval "$1"
455 eval >&3 2>&4 "$test_cleanup"
456 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
463 test_count
=$
(($test_count+1))
465 for skp
in $GIT_SKIP_TESTS
467 case $this_test.
$test_count in
473 if test -z "$to_skip" && test -n "$test_prereq" &&
474 ! test_have_prereq
"$test_prereq"
481 if test "$missing_prereq" != "$test_prereq"
483 of_prereq
=" of $test_prereq"
486 say_color skip
>&3 "skipping test: $@"
487 say_color skip
"ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
496 test_expect_failure
() {
497 test "$#" = 3 && { test_prereq
=$1; shift; } || test_prereq
=
499 error
"bug in the test script: not 2 or 3 parameters to test-expect-failure"
503 say
>&3 "checking known breakage: $2"
505 if [ "$?" = 0 -a "$eval_ret" = 0 ]
507 test_known_broken_ok_
"$1"
509 test_known_broken_failure_
"$1"
515 test_expect_success
() {
516 test "$#" = 3 && { test_prereq
=$1; shift; } || test_prereq
=
518 error
"bug in the test script: not 2 or 3 parameters to test-expect-success"
522 say
>&3 "expecting success: $2"
524 if [ "$?" = 0 -a "$eval_ret" = 0 ]
534 # test_external runs external test scripts that provide continuous
535 # test output about their progress, and succeeds/fails on
536 # zero/non-zero exit code. It outputs the test output on stdout even
537 # in non-verbose mode, and announces the external script with "# run
538 # <n>: ..." before running it. When providing relative paths, keep in
539 # mind that all scripts run in "trash directory".
540 # Usage: test_external description command arguments...
541 # Example: test_external 'Perl API' perl ../path/to/test.pl
543 test "$#" = 4 && { test_prereq
=$1; shift; } || test_prereq
=
545 error
>&5 "bug in the test script: not 3 or 4 parameters to test_external"
549 if ! test_skip
"$descr" "$@"
551 # Announce the script to reduce confusion about the
552 # test output that follows.
553 say_color
"" "# run $test_count: $descr ($*)"
554 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
555 # to be able to use them in script
556 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
557 # Run command; redirect its stderr to &4 as in
558 # test_run_, but keep its stdout on our stdout even in
563 if test $test_external_has_tap -eq 0; then
566 say_color
"" "# test_external test $descr was ok"
567 test_success
=$
(($test_success + 1))
570 if test $test_external_has_tap -eq 0; then
571 test_failure_
"$descr" "$@"
573 say_color error
"# test_external test $descr failed: $@"
574 test_failure
=$
(($test_failure + 1))
580 # Like test_external, but in addition tests that the command generated
581 # no output on stderr.
582 test_external_without_stderr
() {
583 # The temporary file has no (and must have no) security
586 stderr
="$tmp/git-external-stderr.$$.tmp"
587 test_external
"$@" 4> "$stderr"
588 [ -f "$stderr" ] || error
"Internal error: $stderr disappeared."
589 descr
="no stderr: $1"
591 say
>&3 "# expecting no stderr from previous command"
592 if [ ! -s "$stderr" ]; then
595 if test $test_external_has_tap -eq 0; then
598 say_color
"" "# test_external_without_stderr test $descr was ok"
599 test_success
=$
(($test_success + 1))
602 if [ "$verbose" = t
]; then
603 output
=`echo; echo "# Stderr is:"; cat "$stderr"`
607 # rm first in case test_failure exits.
609 if test $test_external_has_tap -eq 0; then
610 test_failure_
"$descr" "$@" "$output"
612 say_color error
"# test_external_without_stderr test $descr failed: $@: $output"
613 test_failure
=$
(($test_failure + 1))
618 # debugging-friendly alternatives to "test [-f|-d|-e]"
619 # The commands test the existence or non-existence of $1. $2 can be
620 # given to provide a more precise diagnosis.
621 test_path_is_file
() {
624 echo "File $1 doesn't exist. $*"
629 test_path_is_dir
() {
632 echo "Directory $1 doesn't exist. $*"
637 test_path_is_missing
() {
642 if [ $# -ge 1 ]; then
649 # test_line_count checks that a file has the number of lines it
650 # ought to. For example:
652 # test_expect_success 'produce exactly one line of output' '
653 # do something >output &&
654 # test_line_count = 1 output
657 # is like "test $(wc -l <output) = 1" except that it passes the
658 # output through when the number of lines is wrong.
663 error
"bug in the test script: not 3 parameters to test_line_count"
664 elif ! test $
(wc -l <"$3") "$1" "$2"
666 echo "test_line_count: line count for $3 !$1 $2"
672 # This is not among top-level (test_expect_success | test_expect_failure)
673 # but is a prefix that can be used in the test script, like:
675 # test_expect_success 'complain and die' '
677 # do something else &&
678 # test_must_fail git checkout ../outerspace
681 # Writing this as "! git checkout ../outerspace" is wrong, because
682 # the failure could be due to a segv. We want a controlled failure.
687 if test $exit_code = 0; then
688 echo >&2 "test_must_fail: command succeeded: $*"
690 elif test $exit_code -gt 129 -a $exit_code -le 192; then
691 echo >&2 "test_must_fail: died by signal: $*"
693 elif test $exit_code = 127; then
694 echo >&2 "test_must_fail: command not found: $*"
700 # Similar to test_must_fail, but tolerates success, too. This is
701 # meant to be used in contexts like:
703 # test_expect_success 'some command works without configuration' '
704 # test_might_fail git config --unset all.configuration &&
708 # Writing "git config --unset all.configuration || :" would be wrong,
709 # because we want to notice if it fails due to segv.
714 if test $exit_code -gt 129 -a $exit_code -le 192; then
715 echo >&2 "test_might_fail: died by signal: $*"
717 elif test $exit_code = 127; then
718 echo >&2 "test_might_fail: command not found: $*"
724 # Similar to test_must_fail and test_might_fail, but check that a
725 # given command exited with a given exit code. Meant to be used as:
727 # test_expect_success 'Merge with d/f conflicts' '
728 # test_expect_code 1 git merge "merge msg" B master
731 test_expect_code
() {
736 if test $exit_code = $want_code
741 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
745 # test_cmp is a helper function to compare actual and expected output.
746 # You can use it like:
748 # test_expect_success 'foo works' '
749 # echo expected >expected &&
751 # test_cmp expected actual
754 # This could be written as either "cmp" or "diff -u", but:
755 # - cmp's output is not nearly as easy to read as diff -u
756 # - not all diff versions understand "-u"
762 # This function can be used to schedule some commands to be run
763 # unconditionally at the end of the test to restore sanity:
765 # test_expect_success 'test core.capslock' '
766 # git config core.capslock true &&
767 # test_when_finished "git config --unset core.capslock" &&
771 # That would be roughly equivalent to
773 # test_expect_success 'test core.capslock' '
774 # git config core.capslock true &&
776 # git config --unset core.capslock
779 # except that the greeting and config --unset must both succeed for
782 test_when_finished
() {
784 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
787 # Most tests can use the created repository, but some may need to create more.
788 # Usage: test_create_repo <directory>
789 test_create_repo
() {
791 error
"bug in the test script: not 1 parameter to test-create-repo"
795 cd "$repo" || error
"Cannot setup test environment"
796 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
797 error
"cannot run git init -- have you built things yet?"
798 mv .git
/hooks .git
/hooks-disabled
805 if test -z "$HARNESS_ACTIVE"; then
806 test_results_dir
="$TEST_DIRECTORY/test-results"
807 mkdir
-p "$test_results_dir"
808 test_results_path
="$test_results_dir/${0%.sh}-$$.counts"
810 cat >>"$test_results_path" <<-EOF
812 success $test_success
820 if test "$test_fixed" != 0
822 say_color pass
"# fixed $test_fixed known breakage(s)"
824 if test "$test_broken" != 0
826 say_color error
"# still have $test_broken known breakage(s)"
827 msg
="remaining $(($test_count-$test_broken)) test(s)"
829 msg
="$test_count test(s)"
831 case "$test_failure" in
833 # Maybe print SKIP message
834 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
836 if test $test_external_has_tap -eq 0; then
837 say_color pass
"# passed all $msg"
838 say
"1..$test_count$skip_all"
841 test -d "$remove_trash" &&
842 cd "$(dirname "$remove_trash")" &&
843 rm -rf "$(basename "$remove_trash")"
848 if test $test_external_has_tap -eq 0; then
849 say_color error
"# failed $test_failure among $msg"
858 # Test the binaries we have just built. The tests are kept in
859 # t/ subdirectory and are run in 'trash directory' subdirectory.
860 if test -z "$TEST_DIRECTORY"
862 # We allow tests to override this, in case they want to run tests
863 # outside of t/, e.g. for running tests on the test library
865 TEST_DIRECTORY
=$
(pwd)
867 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
869 if test -n "$valgrind"
873 test "$1" = "$(readlink "$2")" ||
{
881 while test -d "$2".lock
883 say
"Waiting for lock on $2."
890 make_valgrind_symlink
() {
891 # handle only executables
892 test -x "$1" ||
return
894 base
=$
(basename "$1")
895 symlink_target
=$GIT_BUILD_DIR/$base
896 # do not override scripts
897 if test -x "$symlink_target" &&
898 test ! -d "$symlink_target" &&
899 test "#!" != "$(head -c 2 < "$symlink_target")"
901 symlink_target
=..
/valgrind.sh
905 symlink_target
=..
/unprocessed-script
907 # create the link, or replace it if it is out of date
908 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
911 # override all git executables in TEST_DIRECTORY/..
912 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
913 mkdir
-p "$GIT_VALGRIND"/bin
914 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
916 make_valgrind_symlink
$file
922 ls "$path"/git-
* 2> /dev
/null |
925 make_valgrind_symlink
"$file"
929 PATH
=$GIT_VALGRIND/bin
:$PATH
930 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
932 elif test -n "$GIT_TEST_INSTALLED" ; then
933 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
934 error
"Cannot run git from $GIT_TEST_INSTALLED."
935 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
936 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
937 else # normal case, use ../bin-wrappers only unless $with_dashes:
938 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
939 if ! test -x "$git_bin_dir/git" ; then
940 if test -z "$with_dashes" ; then
941 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
945 PATH
="$git_bin_dir:$PATH"
946 GIT_EXEC_PATH
=$GIT_BUILD_DIR
947 if test -n "$with_dashes" ; then
948 PATH
="$GIT_BUILD_DIR:$PATH"
951 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
953 GIT_CONFIG_NOSYSTEM
=1
955 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
957 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
959 if test -z "$GIT_TEST_CMP"
961 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
963 GIT_TEST_CMP
="$DIFF -c"
965 GIT_TEST_CMP
="$DIFF -u"
969 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
971 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
972 error
"You haven't built things yet, have you?"
975 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
977 GITPYTHONLIB
="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
979 test -d "$GIT_BUILD_DIR"/git_remote_helpers
/build ||
{
980 error
"You haven't built git_remote_helpers yet, have you?"
984 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
; then
985 echo >&2 'You need to build test-chmtime:'
986 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
991 test="trash directory.$(basename "$0" .sh)"
992 test -n "$root" && test="$root/$test"
994 /*) TRASH_DIRECTORY
="$test" ;;
995 *) TRASH_DIRECTORY
="$TEST_DIRECTORY/$test" ;;
997 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
1000 echo >&5 "FATAL: Cannot prepare test area"
1004 HOME
="$TRASH_DIRECTORY"
1007 test_create_repo
"$test"
1008 # Use -P to resolve symlinks in our working directory so that the cwd
1009 # in subprocesses like git equals our $PWD (for pathname comparisons).
1010 cd -P "$test" ||
exit 1
1013 this_test
=${this_test%%-*}
1014 for skp
in $GIT_SKIP_TESTS
1016 case "$this_test" in
1018 say_color skip
>&3 "skipping test $this_test altogether"
1019 skip_all
="skip all tests in $this_test"
1024 # Provide an implementation of the 'yes' utility
1039 # Fix some commands on Windows
1042 # Windows has its own (incompatible) sort and find
1052 # git sees Windows-style pwd
1056 # no POSIX permissions
1057 # backslashes in pathspec are converted to '/'
1058 # exec does not inherit the PID
1059 test_set_prereq MINGW
1060 test_set_prereq SED_STRIPS_CR
1063 test_set_prereq POSIXPERM
1064 test_set_prereq EXECKEEPSPID
1065 test_set_prereq NOT_MINGW
1066 test_set_prereq SED_STRIPS_CR
1069 test_set_prereq POSIXPERM
1070 test_set_prereq BSLASHPSPEC
1071 test_set_prereq EXECKEEPSPID
1072 test_set_prereq NOT_MINGW
1076 test -z "$NO_PERL" && test_set_prereq PERL
1077 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1078 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1080 # Can we rely on git's output in the C locale?
1081 if test -n "$GETTEXT_POISON"
1083 GIT_GETTEXT_POISON
=YesPlease
1084 export GIT_GETTEXT_POISON
1086 test_set_prereq C_LOCALE_OUTPUT
1089 # Use this instead of test_cmp to compare files that contain expected and
1090 # actual output from git commands that can be translated. When running
1091 # under GETTEXT_POISON this pretends that the command produced expected
1094 test -n "$GETTEXT_POISON" || test_cmp
"$@"
1097 # Use this instead of "grep expected-string actual" to see if the
1098 # output from a git command that can be translated either contains an
1099 # expected string, or does not contain an unwanted one. When running
1100 # under GETTEXT_POISON this pretends that the command produced expected
1103 if test -n "$GETTEXT_POISON"
1106 elif test "x!" = "x$1"
1115 # test whether the filesystem supports symbolic links
1116 ln -s x y
2>/dev
/null
&& test -h y
2>/dev
/null
&& test_set_prereq SYMLINKS
1119 # When the tests are run as root, permission tests will report that
1120 # things are writable when they shouldn't be.
1121 test -w / || test_set_prereq SANITY